Package io.vertx.rxjava3.core

## Class Vertx

- java.lang.Object
- - io.vertx.rxjava3.core.Vertx

- All Implemented Interfaces:
    `Measured`

      public class Vertx
      extends Object
      implements Measured

  The entry point into the Vert.x Core API.

  You use an instance of this class for functionality including:

  - Creating TCP clients and servers
  - Creating HTTP clients and servers
  - Creating DNS clients
  - Creating Datagram sockets
  - Setting and cancelling periodic and one-shot timers
  - Getting a reference to the event bus API
  - Getting a reference to the file system API
  - Getting a reference to the shared data API
  - Deploying and undeploying verticles

  Most functionality in Vert.x core is fairly low level.

  To create an instance of this class you can use the static factory methods: `vertx()`, `vertx()` and `clusteredVertx(io.vertx.core.VertxOptions)`.

  Please see the user manual for more detailed usage information.

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static io.vertx.lang.rx.TypeArg<Vertx>` | `__TYPE_ARG` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Vertx​(Vertx delegate)` |
    `Vertx​(Object delegate)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static VertxBuilder` | `builder()` | Return a builder for Vert.x instances which allows to specify SPI such as cluster manager, metrics or tracing.
    `boolean` | `cancelTimer​(long id)` | Cancels the timer with the specified `id`.
    `Completable` | `close()` | Stop the Vertx instance and release any resources held by it.
    `static Single<Vertx>` | `clusteredVertx​(VertxOptions options)` | Creates a clustered instance using the specified options.
    `DatagramSocket` | `createDatagramSocket()` | Create a datagram socket using default options
    `DatagramSocket` | `createDatagramSocket​(DatagramSocketOptions options)` | Create a datagram socket using the specified options
    `DnsClient` | `createDnsClient()` | Create a DNS client to connect to the DNS server configured by `VertxOptions`
    `DnsClient` | `createDnsClient​(int port, String host)` | Create a DNS client to connect to a DNS server at the specified host and port, with the default query timeout (5 seconds)
    `DnsClient` | `createDnsClient​(DnsClientOptions options)` | Create a DNS client to connect to a DNS server
    `HttpClientAgent` | `createHttpClient()` | Create a HTTP/HTTPS client using default options
    `HttpClientAgent` | `createHttpClient​(HttpClientOptions clientOptions)` | Create a HTTP/HTTPS client using the specified client options
    `HttpClientAgent` | `createHttpClient​(HttpClientOptions clientOptions, PoolOptions poolOptions)` | Create a HTTP/HTTPS client using the specified client and pool options
    `HttpClientAgent` | `createHttpClient​(PoolOptions poolOptions)` | Create a HTTP/HTTPS client using the specified pool options
    `HttpServer` | `createHttpServer()` | Create an HTTP/HTTPS server using default options
    `HttpServer` | `createHttpServer​(HttpServerOptions options)` | Create an HTTP/HTTPS server using the specified options
    `NetClient` | `createNetClient()` | Create a TCP/SSL client using default options
    `NetClient` | `createNetClient​(NetClientOptions options)` | Create a TCP/SSL client using the specified options
    `NetServer` | `createNetServer()` | Create a TCP/SSL server using default options
    `NetServer` | `createNetServer​(NetServerOptions options)` | Create a TCP/SSL server using the specified options
    `WorkerExecutor` | `createSharedWorkerExecutor​(String name)` | Like `createSharedWorkerExecutor(java.lang.String)` but with the `VertxOptions` `poolSize`.
    `WorkerExecutor` | `createSharedWorkerExecutor​(String name, int poolSize)` | Like `createSharedWorkerExecutor(java.lang.String)` but with the `VertxOptions` `maxExecuteTime`.
    `WorkerExecutor` | `createSharedWorkerExecutor​(String name, int poolSize, long maxExecuteTime)` | Like `createSharedWorkerExecutor(java.lang.String)` but with the `VertxOptions` `maxExecuteTimeUnit`.
    `WorkerExecutor` | `createSharedWorkerExecutor​(String name, int poolSize, long maxExecuteTime, TimeUnit maxExecuteTimeUnit)` | Create a named worker executor, the executor should be closed when it's not needed anymore to release resources.
    `WebSocketClient` | `createWebSocketClient()` | Create a WebSocket client using default options
    `WebSocketClient` | `createWebSocketClient​(WebSocketClientOptions options)` | Create a WebSocket client using the specified options
    `static Context` | `currentContext()` | Gets the current context
    `Set<String>` | `deploymentIDs()` | Return a Set of deployment IDs for the currently deployed deploymentIDs.
    `Single<String>` | `deployVerticle​(Deployable verticle)` | Deploy a verticle instance that you have created yourself.
    `Single<String>` | `deployVerticle​(Deployable verticle, DeploymentOptions options)` | Like `deployVerticle(java.lang.String)` but `DeploymentOptions` are provided to configure the deployment.
    `Single<String>` | `deployVerticle​(String name)` | Deploy a verticle instance given a name.
    `Single<String>` | `deployVerticle​(String name, DeploymentOptions options)` | Like `deployVerticle(java.lang.String)` but `DeploymentOptions` are provided to configure the deployment.
    `boolean` | `equals​(Object o)` |
    `EventBus` | `eventBus()` | Get the event bus object.
    `Vertx` | `exceptionHandler​(Handler<Throwable> handler)` | Set a default exception handler for `Context`, set on `Context.exceptionHandler(io.vertx.core.Handler<java.lang.Throwable>)` at creation.
    `<T> Maybe<T>` | `executeBlocking​(Callable<T> blockingCodeHandler)` | Like `executeBlocking(java.util.concurrent.Callable<T>, boolean)` called with ordered = true.
    `<T> Maybe<T>` | `executeBlocking​(Callable<T> blockingCodeHandler, boolean ordered)` | Safely execute some blocking code.
    `FileSystem` | `fileSystem()` | Get the filesystem object.
    `Vertx` | `getDelegate()` |
    `Context` | `getOrCreateContext()` | Gets the current context, or creates one if there isn't one
    `int` | `hashCode()` |
    `HttpClientBuilder` | `httpClientBuilder()` | Provide a builder for , it can be used to configure advanced HTTP client settings like a redirect handler or a connection handler.
    `boolean` | `isClustered()` | Is this Vert.x instance clustered?
    `boolean` | `isMetricsEnabled()` | Whether the metrics are enabled for this measured object
    `boolean` | `isNativeTransportEnabled()` |
    `static Vertx` | `newInstance​(Vertx arg)` |
    `void` | `registerVerticleFactory​(VerticleFactory factory)` | Register a `VerticleFactory` that can be used for deploying Verticles based on an identifier.
    `void` | `runOnContext​(Handler<Void> action)` | Puts the handler on the event queue for the current context so it will be run asynchronously ASAP after all preceeding events have been handled.
    `Completable` | `rxClose()` | Stop the Vertx instance and release any resources held by it.
    `static Single<Vertx>` | `rxClusteredVertx​(VertxOptions options)` | Creates a clustered instance using the specified options.
    `Single<String>` | `rxDeployVerticle​(Deployable verticle)` | Deploy a verticle instance that you have created yourself.
    `Single<String>` | `rxDeployVerticle​(Deployable verticle, DeploymentOptions options)` | Like `deployVerticle(java.lang.String)` but `DeploymentOptions` are provided to configure the deployment.
    `Single<String>` | `rxDeployVerticle​(String name)` | Deploy a verticle instance given a name.
    `Single<String>` | `rxDeployVerticle​(String name, DeploymentOptions options)` | Like `deployVerticle(java.lang.String)` but `DeploymentOptions` are provided to configure the deployment.
    `<T> Maybe<T>` | `rxExecuteBlocking​(Callable<T> blockingCodeHandler)` | Like `executeBlocking(java.util.concurrent.Callable<T>, boolean)` called with ordered = true.
    `<T> Maybe<T>` | `rxExecuteBlocking​(Callable<T> blockingCodeHandler, boolean ordered)` | Safely execute some blocking code.
    `Completable` | `rxUndeploy​(String deploymentID)` | Undeploy a verticle deployment.
    `long` | `setPeriodic​(long initialDelay, long delay, Handler<Long> handler)` | Set a periodic timer to fire every `delay` milliseconds with initial delay, at which point `handler` will be called with the id of the timer.
    `long` | `setPeriodic​(long delay, Handler<Long> handler)` | Set a periodic timer to fire every `delay` milliseconds, at which point `handler` will be called with the id of the timer.
    `long` | `setTimer​(long delay, Handler<Long> handler)` | Set a one-shot timer to fire after `delay` milliseconds, at which point `handler` will be called with the id of the timer.
    `SharedData` | `sharedData()` | Get the shared data object.
    `Timer` | `timer​(long delay)` | Like `timer(long)` with a unit in millis.
    `Timer` | `timer​(long delay, TimeUnit unit)` | Create a timer task configured with the specified `delay`, when the timeout fires the timer future is succeeded, when the timeout is cancelled the timer future is failed with a `CancellationException` instance.
    `String` | `toString()` |
    `Throwable` | `unavailableNativeTransportCause()` |
    `Completable` | `undeploy​(String deploymentID)` | Undeploy a verticle deployment.
    `void` | `unregisterVerticleFactory​(VerticleFactory factory)` | Unregister a `VerticleFactory`
    `Set<VerticleFactory>` | `verticleFactories()` | Return the Set of currently registered verticle factories.
    `static Vertx` | `vertx()` | Creates a non clustered instance using default options.
    `static Vertx` | `vertx​(VertxOptions options)` | Creates a non clustered instance using the specified options

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### __TYPE_ARG

          public static final io.vertx.lang.rx.TypeArg<Vertx> __TYPE_ARG

  - ### Constructor Detail

    - #### Vertx

          public Vertx​(Vertx delegate)

    - #### Vertx

          public Vertx​(Object delegate)

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### equals

          public boolean equals​(Object o)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### getDelegate

          public Vertx getDelegate()

      Specified by:
        `getDelegate` in interface `Measured`

    - #### isMetricsEnabled

          public boolean isMetricsEnabled()

      Whether the metrics are enabled for this measured object
      Specified by:
        `isMetricsEnabled` in interface `Measured`
      Returns:
        `true` if metrics are enabled

    - #### builder

          public static VertxBuilder builder()

      Return a builder for Vert.x instances which allows to specify SPI such as cluster manager, metrics or tracing.
      Returns:
        a Vert.x instance builder

    - #### vertx

          public static Vertx vertx()

      Creates a non clustered instance using default options.
      Returns:
        the instance

    - #### vertx

          public static Vertx vertx​(VertxOptions options)

      Creates a non clustered instance using the specified options
      Parameters:
        `options` - the options to use
      Returns:
        the instance

    - #### clusteredVertx

          public static Single<Vertx> clusteredVertx​(VertxOptions options)

      Creates a clustered instance using the specified options.

      The instance is created asynchronously and the returned future is completed with the result when it is ready.

      Parameters:
        `options` - the options to use
      Returns:
        a future completed with the clustered vertx

    - #### rxClusteredVertx

          public static Single<Vertx> rxClusteredVertx​(VertxOptions options)

      Creates a clustered instance using the specified options.

      The instance is created asynchronously and the returned future is completed with the result when it is ready.

      Parameters:
        `options` - the options to use
      Returns:
        a future completed with the clustered vertx

    - #### currentContext

          public static Context currentContext()

      Gets the current context
      Returns:
        The current context or `null` if there is no current context

    - #### getOrCreateContext

          public Context getOrCreateContext()

      Gets the current context, or creates one if there isn't one
      Returns:
        The current context (created if didn't exist)

    - #### createNetServer

          public NetServer createNetServer​(NetServerOptions options)

      Create a TCP/SSL server using the specified options
      Parameters:
        `options` - the options to use
      Returns:
        the server

    - #### createNetServer

          public NetServer createNetServer()

      Create a TCP/SSL server using default options
      Returns:
        the server

    - #### createNetClient

          public NetClient createNetClient​(NetClientOptions options)

      Create a TCP/SSL client using the specified options
      Parameters:
        `options` - the options to use
      Returns:
        the client

    - #### createNetClient

          public NetClient createNetClient()

      Create a TCP/SSL client using default options
      Returns:
        the client

    - #### createHttpServer

          public HttpServer createHttpServer​(HttpServerOptions options)

      Create an HTTP/HTTPS server using the specified options
      Parameters:
        `options` - the options to use
      Returns:
        the server

    - #### createHttpServer

          public HttpServer createHttpServer()

      Create an HTTP/HTTPS server using default options
      Returns:
        the server

    - #### createWebSocketClient

          public WebSocketClient createWebSocketClient()

      Create a WebSocket client using default options
      Returns:
        the client

    - #### createWebSocketClient

          public WebSocketClient createWebSocketClient​(WebSocketClientOptions options)

      Create a WebSocket client using the specified options
      Parameters:
        `options` - the options to use
      Returns:
        the client

    - #### httpClientBuilder

          public HttpClientBuilder httpClientBuilder()

      Provide a builder for , it can be used to configure advanced HTTP client settings like a redirect handler or a connection handler.

      Example usage: `HttpClient client = vertx.httpClientBuilder().with(options).withConnectHandler(conn -> ...).build()`

      Returns:

    - #### createHttpClient

          public HttpClientAgent createHttpClient​(HttpClientOptions clientOptions,
                                                  PoolOptions poolOptions)

      Create a HTTP/HTTPS client using the specified client and pool options
      Parameters:
        `clientOptions` - the client options to use
        `poolOptions` - the pool options to use
      Returns:
        the client

    - #### createHttpClient

          public HttpClientAgent createHttpClient​(HttpClientOptions clientOptions)

      Create a HTTP/HTTPS client using the specified client options
      Parameters:
        `clientOptions` - the options to use
      Returns:
        the client

    - #### createHttpClient

          public HttpClientAgent createHttpClient​(PoolOptions poolOptions)

      Create a HTTP/HTTPS client using the specified pool options
      Parameters:
        `poolOptions` - the pool options to use
      Returns:
        the client

    - #### createHttpClient

          public HttpClientAgent createHttpClient()

      Create a HTTP/HTTPS client using default options
      Returns:
        the client

    - #### createDatagramSocket

          public DatagramSocket createDatagramSocket​(DatagramSocketOptions options)

      Create a datagram socket using the specified options
      Parameters:
        `options` - the options to use
      Returns:
        the socket

    - #### createDatagramSocket

          public DatagramSocket createDatagramSocket()

      Create a datagram socket using default options
      Returns:
        the socket

    - #### fileSystem

          public FileSystem fileSystem()

      Get the filesystem object. There is a single instance of FileSystem per Vertx instance.
      Returns:
        the filesystem object

    - #### eventBus

          public EventBus eventBus()

      Get the event bus object. There is a single instance of EventBus per Vertx instance.
      Returns:
        the event bus object

    - #### createDnsClient

          public DnsClient createDnsClient​(int port,
                                           String host)

      Create a DNS client to connect to a DNS server at the specified host and port, with the default query timeout (5 seconds)

      Parameters:
        `port` - the port
        `host` - the host
      Returns:
        the DNS client

    - #### createDnsClient

          public DnsClient createDnsClient()

      Create a DNS client to connect to the DNS server configured by `VertxOptions`

      DNS client takes the first configured resolver address provided by }

      Returns:
        the DNS client

    - #### createDnsClient

          public DnsClient createDnsClient​(DnsClientOptions options)

      Create a DNS client to connect to a DNS server
      Parameters:
        `options` - the client options
      Returns:
        the DNS client

    - #### sharedData

          public SharedData sharedData()

      Get the shared data object. There is a single instance of SharedData per Vertx instance.
      Returns:
        the shared data object

    - #### timer

          public Timer timer​(long delay)

      Like `timer(long)` with a unit in millis.
      Parameters:
        `delay` -
      Returns:

    - #### timer

          public Timer timer​(long delay,
                             TimeUnit unit)

      Create a timer task configured with the specified `delay`, when the timeout fires the timer future is succeeded, when the timeout is cancelled the timer future is failed with a `CancellationException` instance.
      Parameters:
        `delay` - the delay
        `unit` - the delay unit
      Returns:
        the timer object

    - #### setTimer

          public long setTimer​(long delay,
                               Handler<Long> handler)

      Set a one-shot timer to fire after `delay` milliseconds, at which point `handler` will be called with the id of the timer.
      Parameters:
        `delay` - the delay in milliseconds, after which the timer will fire
        `handler` - the handler that will be called with the timer ID when the timer fires
      Returns:
        the unique ID of the timer

    - #### setPeriodic

          public long setPeriodic​(long delay,
                                  Handler<Long> handler)

      Set a periodic timer to fire every `delay` milliseconds, at which point `handler` will be called with the id of the timer.
      Parameters:
        `delay` - the delay in milliseconds, after which the timer will fire
        `handler` - the handler that will be called with the timer ID when the timer fires
      Returns:
        the unique ID of the timer

    - #### setPeriodic

          public long setPeriodic​(long initialDelay,
                                  long delay,
                                  Handler<Long> handler)

      Set a periodic timer to fire every `delay` milliseconds with initial delay, at which point `handler` will be called with the id of the timer.
      Parameters:
        `initialDelay` - the initial delay in milliseconds
        `delay` - the delay in milliseconds, after which the timer will fire
        `handler` - the handler that will be called with the timer ID when the timer fires
      Returns:
        the unique ID of the timer

    - #### cancelTimer

          public boolean cancelTimer​(long id)

      Cancels the timer with the specified `id`.
      Parameters:
        `id` - The id of the timer to cancel
      Returns:
        true if the timer was successfully cancelled, or false if the timer does not exist.

    - #### runOnContext

          public void runOnContext​(Handler<Void> action)

      Puts the handler on the event queue for the current context so it will be run asynchronously ASAP after all preceeding events have been handled.
      Parameters:
        `action` - - a handler representing the action to execute

    - #### close

          public Completable close()

      Stop the Vertx instance and release any resources held by it.

      The instance cannot be used after it has been closed.

      The actual close is asynchronous and may not complete until after the call has returned.

      Returns:
        a future completed with the result

    - #### rxClose

          public Completable rxClose()

      Stop the Vertx instance and release any resources held by it.

      The instance cannot be used after it has been closed.

      The actual close is asynchronous and may not complete until after the call has returned.

      Returns:
        a future completed with the result

    - #### deployVerticle

          public Single<String> deployVerticle​(String name)

      Deploy a verticle instance given a name.

      Given the name, Vert.x selects a instance to use to instantiate the verticle.

      For the rules on how factories are selected please consult the user manual.

      If the deployment is successful the result will contain a String representing the unique deployment ID of the deployment.

      This deployment ID can subsequently be used to undeploy the verticle.

      Parameters:
        `name` - the name.
      Returns:
        a future completed with the result

    - #### rxDeployVerticle

          public Single<String> rxDeployVerticle​(String name)

      Deploy a verticle instance given a name.

      Given the name, Vert.x selects a instance to use to instantiate the verticle.

      For the rules on how factories are selected please consult the user manual.

      If the deployment is successful the result will contain a String representing the unique deployment ID of the deployment.

      This deployment ID can subsequently be used to undeploy the verticle.

      Parameters:
        `name` - the name.
      Returns:
        a future completed with the result

    - #### deployVerticle

          public Single<String> deployVerticle​(String name,
                                               DeploymentOptions options)

      Like `deployVerticle(java.lang.String)` but `DeploymentOptions` are provided to configure the deployment.
      Parameters:
        `name` - the name
        `options` - the deployment options.
      Returns:
        a future completed with the result

    - #### rxDeployVerticle

          public Single<String> rxDeployVerticle​(String name,
                                                 DeploymentOptions options)

      Like `deployVerticle(java.lang.String)` but `DeploymentOptions` are provided to configure the deployment.
      Parameters:
        `name` - the name
        `options` - the deployment options.
      Returns:
        a future completed with the result

    - #### undeploy

          public Completable undeploy​(String deploymentID)

      Undeploy a verticle deployment.

      The actual undeployment happens asynchronously and may not complete until after the method has returned.

      Parameters:
        `deploymentID` - the deployment ID
      Returns:
        a future completed with the result

    - #### rxUndeploy

          public Completable rxUndeploy​(String deploymentID)

      Undeploy a verticle deployment.

      The actual undeployment happens asynchronously and may not complete until after the method has returned.

      Parameters:
        `deploymentID` - the deployment ID
      Returns:
        a future completed with the result

    - #### deploymentIDs

          public Set<String> deploymentIDs()

      Return a Set of deployment IDs for the currently deployed deploymentIDs.
      Returns:
        Set of deployment IDs

    - #### isClustered

          public boolean isClustered()

      Is this Vert.x instance clustered?
      Returns:
        true if clustered

    - #### createSharedWorkerExecutor

          public WorkerExecutor createSharedWorkerExecutor​(String name)

      Like `createSharedWorkerExecutor(java.lang.String)` but with the `VertxOptions` `poolSize`.
      Parameters:
        `name` -
      Returns:

    - #### createSharedWorkerExecutor

          public WorkerExecutor createSharedWorkerExecutor​(String name,
                                                           int poolSize)

      Like `createSharedWorkerExecutor(java.lang.String)` but with the `VertxOptions` `maxExecuteTime`.
      Parameters:
        `name` -
        `poolSize` -
      Returns:

    - #### createSharedWorkerExecutor

          public WorkerExecutor createSharedWorkerExecutor​(String name,
                                                           int poolSize,
                                                           long maxExecuteTime)

      Like `createSharedWorkerExecutor(java.lang.String)` but with the `VertxOptions` `maxExecuteTimeUnit`.
      Parameters:
        `name` -
        `poolSize` -
        `maxExecuteTime` -
      Returns:

    - #### createSharedWorkerExecutor

          public WorkerExecutor createSharedWorkerExecutor​(String name,
                                                           int poolSize,
                                                           long maxExecuteTime,
                                                           TimeUnit maxExecuteTimeUnit)

      Create a named worker executor, the executor should be closed when it's not needed anymore to release resources.

      This method can be called mutiple times with the same `name`. Executors with the same name will share the same worker pool. The worker pool size , max execute time and unit of max execute time are set when the worker pool is created and won't change after.

      The worker pool is released when all the `WorkerExecutor` sharing the same name are closed.

      Parameters:
        `name` - the name of the worker executor
        `poolSize` - the size of the pool
        `maxExecuteTime` - the value of max worker execute time
        `maxExecuteTimeUnit` - the value of unit of max worker execute time
      Returns:
        the named worker executor

    - #### isNativeTransportEnabled

          public boolean isNativeTransportEnabled()

      Returns:
        whether the native transport is used

    - #### unavailableNativeTransportCause

          public Throwable unavailableNativeTransportCause()

      Returns:
        the error (if any) that cause the unavailability of native transport when `isNativeTransportEnabled()` returns `false`.

    - #### exceptionHandler

          public Vertx exceptionHandler​(Handler<Throwable> handler)

      Set a default exception handler for `Context`, set on `Context.exceptionHandler(io.vertx.core.Handler<java.lang.Throwable>)` at creation.
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### deployVerticle

          public Single<String> deployVerticle​(Deployable verticle)

      Deploy a verticle instance that you have created yourself.

      Vert.x will assign the verticle a context and start the verticle.

      The actual deploy happens asynchronously and may not complete until after the call has returned.

      If the deployment is successful the result will contain a string representing the unique deployment ID of the deployment.

      This deployment ID can subsequently be used to undeploy the verticle.

      Parameters:
        `verticle` - the verticle instance to deploy.
      Returns:
        a future completed with the result

    - #### rxDeployVerticle

          public Single<String> rxDeployVerticle​(Deployable verticle)

      Deploy a verticle instance that you have created yourself.

      Vert.x will assign the verticle a context and start the verticle.

      The actual deploy happens asynchronously and may not complete until after the call has returned.

      If the deployment is successful the result will contain a string representing the unique deployment ID of the deployment.

      This deployment ID can subsequently be used to undeploy the verticle.

      Parameters:
        `verticle` - the verticle instance to deploy.
      Returns:
        a future completed with the result

    - #### deployVerticle

          public Single<String> deployVerticle​(Deployable verticle,
                                               DeploymentOptions options)

      Like `deployVerticle(java.lang.String)` but `DeploymentOptions` are provided to configure the deployment.
      Parameters:
        `verticle` - the verticle instance to deploy
        `options` - the deployment options.
      Returns:
        a future completed with the result

    - #### rxDeployVerticle

          public Single<String> rxDeployVerticle​(Deployable verticle,
                                                 DeploymentOptions options)

      Like `deployVerticle(java.lang.String)` but `DeploymentOptions` are provided to configure the deployment.
      Parameters:
        `verticle` - the verticle instance to deploy
        `options` - the deployment options.
      Returns:
        a future completed with the result

    - #### registerVerticleFactory

          public void registerVerticleFactory​(VerticleFactory factory)

      Register a `VerticleFactory` that can be used for deploying Verticles based on an identifier.
      Parameters:
        `factory` - the factory to register

    - #### unregisterVerticleFactory

          public void unregisterVerticleFactory​(VerticleFactory factory)

      Unregister a `VerticleFactory`
      Parameters:
        `factory` - the factory to unregister

    - #### verticleFactories

          public Set<VerticleFactory> verticleFactories()

      Return the Set of currently registered verticle factories.
      Returns:
        the set of verticle factories

    - #### executeBlocking

          public <T> Maybe<T> executeBlocking​(Callable<T> blockingCodeHandler,
                                              boolean ordered)

      Safely execute some blocking code.

      Executes the blocking code in the handler `blockingCodeHandler` using a thread from the worker pool.

      The returned future will be completed with the result on the original context (i.e. on the original event loop of the caller) or failed when the handler throws an exception.

      In the `blockingCodeHandler` the current context remains the original context and therefore any task scheduled in the `blockingCodeHandler` will be executed on this context and not on the worker thread.

      The blocking code should block for a reasonable amount of time (i.e no more than a few seconds). Long blocking operations or polling operations (i.e a thread that spin in a loop polling events in a blocking fashion) are precluded.

      When the blocking operation lasts more than the 10 seconds, a message will be printed on the console by the blocked thread checker.

      Long blocking operations should use a dedicated thread managed by the application, which can interact with verticles using the event-bus or `Context.runOnContext(io.vertx.core.Handler<java.lang.Void>)`

      Parameters:
        `blockingCodeHandler` - handler representing the blocking code to run
        `ordered` - if true then if executeBlocking is called several times on the same context, the executions for that context will be executed serially, not in parallel. if false then they will be no ordering guarantees
      Returns:
        a future completed when the blocking code is complete

    - #### rxExecuteBlocking

          public <T> Maybe<T> rxExecuteBlocking​(Callable<T> blockingCodeHandler,
                                                boolean ordered)

      Safely execute some blocking code.

      Executes the blocking code in the handler `blockingCodeHandler` using a thread from the worker pool.

      The returned future will be completed with the result on the original context (i.e. on the original event loop of the caller) or failed when the handler throws an exception.

      In the `blockingCodeHandler` the current context remains the original context and therefore any task scheduled in the `blockingCodeHandler` will be executed on this context and not on the worker thread.

      The blocking code should block for a reasonable amount of time (i.e no more than a few seconds). Long blocking operations or polling operations (i.e a thread that spin in a loop polling events in a blocking fashion) are precluded.

      When the blocking operation lasts more than the 10 seconds, a message will be printed on the console by the blocked thread checker.

      Long blocking operations should use a dedicated thread managed by the application, which can interact with verticles using the event-bus or `Context.runOnContext(io.vertx.core.Handler<java.lang.Void>)`

      Parameters:
        `blockingCodeHandler` - handler representing the blocking code to run
        `ordered` - if true then if executeBlocking is called several times on the same context, the executions for that context will be executed serially, not in parallel. if false then they will be no ordering guarantees
      Returns:
        a future completed when the blocking code is complete

    - #### executeBlocking

          public <T> Maybe<T> executeBlocking​(Callable<T> blockingCodeHandler)

      Like `executeBlocking(java.util.concurrent.Callable<T>, boolean)` called with ordered = true.
      Parameters:
        `blockingCodeHandler` -
      Returns:

    - #### rxExecuteBlocking

          public <T> Maybe<T> rxExecuteBlocking​(Callable<T> blockingCodeHandler)

      Like `executeBlocking(java.util.concurrent.Callable<T>, boolean)` called with ordered = true.
      Parameters:
        `blockingCodeHandler` -
      Returns:

    - #### newInstance

          public static Vertx newInstance​(Vertx arg)